git-rebase--interactive.shon commit rebase -i: more graceful handling of invalid commands (f1be316)
   1#!/bin/sh
   2#
   3# Copyright (c) 2006 Johannes E. Schindelin
   4
   5# SHORT DESCRIPTION
   6#
   7# This script makes it easy to fix up commits in the middle of a series,
   8# and rearrange commits.
   9#
  10# The original idea comes from Eric W. Biederman, in
  11# http://article.gmane.org/gmane.comp.version-control.git/22407
  12
  13OPTIONS_KEEPDASHDASH=
  14OPTIONS_SPEC="\
  15git-rebase [-i] [options] [--] <upstream> [<branch>]
  16git-rebase [-i] (--continue | --abort | --skip)
  17--
  18 Available options are
  19v,verbose          display a diffstat of what changed upstream
  20onto=              rebase onto given branch instead of upstream
  21p,preserve-merges  try to recreate merges instead of ignoring them
  22s,strategy=        use the given merge strategy
  23m,merge            always used (no-op)
  24i,interactive      always used (no-op)
  25 Actions:
  26continue           continue rebasing process
  27abort              abort rebasing process and restore original branch
  28skip               skip current patch and continue rebasing process
  29no-verify          override pre-rebase hook from stopping the operation
  30root               rebase all reachable commmits up to the root(s)
  31"
  32
  33. git-sh-setup
  34require_work_tree
  35
  36DOTEST="$GIT_DIR/rebase-merge"
  37TODO="$DOTEST"/git-rebase-todo
  38DONE="$DOTEST"/done
  39MSG="$DOTEST"/message
  40SQUASH_MSG="$DOTEST"/message-squash
  41REWRITTEN="$DOTEST"/rewritten
  42DROPPED="$DOTEST"/dropped
  43PRESERVE_MERGES=
  44STRATEGY=
  45ONTO=
  46VERBOSE=
  47OK_TO_SKIP_PRE_REBASE=
  48REBASE_ROOT=
  49
  50GIT_CHERRY_PICK_HELP="  After resolving the conflicts,
  51mark the corrected paths with 'git add <paths>', and
  52run 'git rebase --continue'"
  53export GIT_CHERRY_PICK_HELP
  54
  55warn () {
  56        echo "$*" >&2
  57}
  58
  59output () {
  60        case "$VERBOSE" in
  61        '')
  62                output=$("$@" 2>&1 )
  63                status=$?
  64                test $status != 0 && printf "%s\n" "$output"
  65                return $status
  66                ;;
  67        *)
  68                "$@"
  69                ;;
  70        esac
  71}
  72
  73run_pre_rebase_hook () {
  74        if test -z "$OK_TO_SKIP_PRE_REBASE" &&
  75           test -x "$GIT_DIR/hooks/pre-rebase"
  76        then
  77                "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
  78                        echo >&2 "The pre-rebase hook refused to rebase."
  79                        exit 1
  80                }
  81        fi
  82}
  83
  84require_clean_work_tree () {
  85        # test if working tree is dirty
  86        git rev-parse --verify HEAD > /dev/null &&
  87        git update-index --ignore-submodules --refresh &&
  88        git diff-files --quiet --ignore-submodules &&
  89        git diff-index --cached --quiet HEAD --ignore-submodules -- ||
  90        die "Working tree is dirty"
  91}
  92
  93ORIG_REFLOG_ACTION="$GIT_REFLOG_ACTION"
  94
  95comment_for_reflog () {
  96        case "$ORIG_REFLOG_ACTION" in
  97        ''|rebase*)
  98                GIT_REFLOG_ACTION="rebase -i ($1)"
  99                export GIT_REFLOG_ACTION
 100                ;;
 101        esac
 102}
 103
 104last_count=
 105mark_action_done () {
 106        sed -e 1q < "$TODO" >> "$DONE"
 107        sed -e 1d < "$TODO" >> "$TODO".new
 108        mv -f "$TODO".new "$TODO"
 109        count=$(grep -c '^[^#]' < "$DONE")
 110        total=$(($count+$(grep -c '^[^#]' < "$TODO")))
 111        if test "$last_count" != "$count"
 112        then
 113                last_count=$count
 114                printf "Rebasing (%d/%d)\r" $count $total
 115                test -z "$VERBOSE" || echo
 116        fi
 117}
 118
 119make_patch () {
 120        sha1_and_parents="$(git rev-list --parents -1 "$1")"
 121        case "$sha1_and_parents" in
 122        ?*' '?*' '?*)
 123                git diff --cc $sha1_and_parents
 124                ;;
 125        ?*' '?*)
 126                git diff-tree -p "$1^!"
 127                ;;
 128        *)
 129                echo "Root commit"
 130                ;;
 131        esac > "$DOTEST"/patch
 132        test -f "$DOTEST"/message ||
 133                git cat-file commit "$1" | sed "1,/^$/d" > "$DOTEST"/message
 134        test -f "$DOTEST"/author-script ||
 135                get_author_ident_from_commit "$1" > "$DOTEST"/author-script
 136}
 137
 138die_with_patch () {
 139        make_patch "$1"
 140        git rerere
 141        die "$2"
 142}
 143
 144die_abort () {
 145        rm -rf "$DOTEST"
 146        die "$1"
 147}
 148
 149has_action () {
 150        grep '^[^#]' "$1" >/dev/null
 151}
 152
 153pick_one () {
 154        no_ff=
 155        case "$1" in -n) sha1=$2; no_ff=t ;; *) sha1=$1 ;; esac
 156        output git rev-parse --verify $sha1 || die "Invalid commit name: $sha1"
 157        test -d "$REWRITTEN" &&
 158                pick_one_preserving_merges "$@" && return
 159        if test ! -z "$REBASE_ROOT"
 160        then
 161                output git cherry-pick "$@"
 162                return
 163        fi
 164        parent_sha1=$(git rev-parse --verify $sha1^) ||
 165                die "Could not get the parent of $sha1"
 166        current_sha1=$(git rev-parse --verify HEAD)
 167        if test "$no_ff$current_sha1" = "$parent_sha1"; then
 168                output git reset --hard $sha1
 169                test "a$1" = a-n && output git reset --soft $current_sha1
 170                sha1=$(git rev-parse --short $sha1)
 171                output warn Fast forward to $sha1
 172        else
 173                output git cherry-pick "$@"
 174        fi
 175}
 176
 177pick_one_preserving_merges () {
 178        fast_forward=t
 179        case "$1" in
 180        -n)
 181                fast_forward=f
 182                sha1=$2
 183                ;;
 184        *)
 185                sha1=$1
 186                ;;
 187        esac
 188        sha1=$(git rev-parse $sha1)
 189
 190        if test -f "$DOTEST"/current-commit
 191        then
 192                if test "$fast_forward" = t
 193                then
 194                        cat "$DOTEST"/current-commit | while read current_commit
 195                        do
 196                                git rev-parse HEAD > "$REWRITTEN"/$current_commit
 197                        done
 198                        rm "$DOTEST"/current-commit ||
 199                        die "Cannot write current commit's replacement sha1"
 200                fi
 201        fi
 202
 203        echo $sha1 >> "$DOTEST"/current-commit
 204
 205        # rewrite parents; if none were rewritten, we can fast-forward.
 206        new_parents=
 207        pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
 208        if test "$pend" = " "
 209        then
 210                pend=" root"
 211        fi
 212        while [ "$pend" != "" ]
 213        do
 214                p=$(expr "$pend" : ' \([^ ]*\)')
 215                pend="${pend# $p}"
 216
 217                if test -f "$REWRITTEN"/$p
 218                then
 219                        new_p=$(cat "$REWRITTEN"/$p)
 220
 221                        # If the todo reordered commits, and our parent is marked for
 222                        # rewriting, but hasn't been gotten to yet, assume the user meant to
 223                        # drop it on top of the current HEAD
 224                        if test -z "$new_p"
 225                        then
 226                                new_p=$(git rev-parse HEAD)
 227                        fi
 228
 229                        test $p != $new_p && fast_forward=f
 230                        case "$new_parents" in
 231                        *$new_p*)
 232                                ;; # do nothing; that parent is already there
 233                        *)
 234                                new_parents="$new_parents $new_p"
 235                                ;;
 236                        esac
 237                else
 238                        if test -f "$DROPPED"/$p
 239                        then
 240                                fast_forward=f
 241                                replacement="$(cat "$DROPPED"/$p)"
 242                                test -z "$replacement" && replacement=root
 243                                pend=" $replacement$pend"
 244                        else
 245                                new_parents="$new_parents $p"
 246                        fi
 247                fi
 248        done
 249        case $fast_forward in
 250        t)
 251                output warn "Fast forward to $sha1"
 252                output git reset --hard $sha1 ||
 253                        die "Cannot fast forward to $sha1"
 254                ;;
 255        f)
 256                first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
 257
 258                if [ "$1" != "-n" ]
 259                then
 260                        # detach HEAD to current parent
 261                        output git checkout $first_parent 2> /dev/null ||
 262                                die "Cannot move HEAD to $first_parent"
 263                fi
 264
 265                case "$new_parents" in
 266                ' '*' '*)
 267                        test "a$1" = a-n && die "Refusing to squash a merge: $sha1"
 268
 269                        # redo merge
 270                        author_script=$(get_author_ident_from_commit $sha1)
 271                        eval "$author_script"
 272                        msg="$(git cat-file commit $sha1 | sed -e '1,/^$/d')"
 273                        # No point in merging the first parent, that's HEAD
 274                        new_parents=${new_parents# $first_parent}
 275                        if ! GIT_AUTHOR_NAME="$GIT_AUTHOR_NAME" \
 276                                GIT_AUTHOR_EMAIL="$GIT_AUTHOR_EMAIL" \
 277                                GIT_AUTHOR_DATE="$GIT_AUTHOR_DATE" \
 278                                output git merge $STRATEGY -m "$msg" \
 279                                        $new_parents
 280                        then
 281                                printf "%s\n" "$msg" > "$GIT_DIR"/MERGE_MSG
 282                                die_with_patch $sha1 "Error redoing merge $sha1"
 283                        fi
 284                        ;;
 285                *)
 286                        output git cherry-pick "$@" ||
 287                                die_with_patch $sha1 "Could not pick $sha1"
 288                        ;;
 289                esac
 290                ;;
 291        esac
 292}
 293
 294nth_string () {
 295        case "$1" in
 296        *1[0-9]|*[04-9]) echo "$1"th;;
 297        *1) echo "$1"st;;
 298        *2) echo "$1"nd;;
 299        *3) echo "$1"rd;;
 300        esac
 301}
 302
 303make_squash_message () {
 304        if test -f "$SQUASH_MSG"; then
 305                COUNT=$(($(sed -n "s/^# This is [^0-9]*\([1-9][0-9]*\).*/\1/p" \
 306                        < "$SQUASH_MSG" | sed -ne '$p')+1))
 307                echo "# This is a combination of $COUNT commits."
 308                sed -e 1d -e '2,/^./{
 309                        /^$/d
 310                }' <"$SQUASH_MSG"
 311        else
 312                COUNT=2
 313                echo "# This is a combination of two commits."
 314                echo "# The first commit's message is:"
 315                echo
 316                git cat-file commit HEAD | sed -e '1,/^$/d'
 317        fi
 318        echo
 319        echo "# This is the $(nth_string $COUNT) commit message:"
 320        echo
 321        git cat-file commit $1 | sed -e '1,/^$/d'
 322}
 323
 324peek_next_command () {
 325        sed -n "1s/ .*$//p" < "$TODO"
 326}
 327
 328do_next () {
 329        rm -f "$DOTEST"/message "$DOTEST"/author-script \
 330                "$DOTEST"/amend || exit
 331        read command sha1 rest < "$TODO"
 332        case "$command" in
 333        '#'*|''|noop)
 334                mark_action_done
 335                ;;
 336        pick|p)
 337                comment_for_reflog pick
 338
 339                mark_action_done
 340                pick_one $sha1 ||
 341                        die_with_patch $sha1 "Could not apply $sha1... $rest"
 342                ;;
 343        edit|e)
 344                comment_for_reflog edit
 345
 346                mark_action_done
 347                pick_one $sha1 ||
 348                        die_with_patch $sha1 "Could not apply $sha1... $rest"
 349                make_patch $sha1
 350                git rev-parse --verify HEAD > "$DOTEST"/amend
 351                warn "Stopped at $sha1... $rest"
 352                warn "You can amend the commit now, with"
 353                warn
 354                warn "  git commit --amend"
 355                warn
 356                warn "Once you are satisfied with your changes, run"
 357                warn
 358                warn "  git rebase --continue"
 359                warn
 360                exit 0
 361                ;;
 362        squash|s)
 363                comment_for_reflog squash
 364
 365                test -f "$DONE" && has_action "$DONE" ||
 366                        die "Cannot 'squash' without a previous commit"
 367
 368                mark_action_done
 369                make_squash_message $sha1 > "$MSG"
 370                failed=f
 371                author_script=$(get_author_ident_from_commit HEAD)
 372                output git reset --soft HEAD^
 373                pick_one -n $sha1 || failed=t
 374                case "$(peek_next_command)" in
 375                squash|s)
 376                        USE_OUTPUT=output
 377                        MSG_OPT=-F
 378                        EDIT_OR_FILE="$MSG"
 379                        cp "$MSG" "$SQUASH_MSG"
 380                        ;;
 381                *)
 382                        USE_OUTPUT=
 383                        MSG_OPT=
 384                        EDIT_OR_FILE=-e
 385                        rm -f "$SQUASH_MSG" || exit
 386                        cp "$MSG" "$GIT_DIR"/SQUASH_MSG
 387                        rm -f "$GIT_DIR"/MERGE_MSG || exit
 388                        ;;
 389                esac
 390                echo "$author_script" > "$DOTEST"/author-script
 391                if test $failed = f
 392                then
 393                        # This is like --amend, but with a different message
 394                        eval "$author_script"
 395                        GIT_AUTHOR_NAME="$GIT_AUTHOR_NAME" \
 396                        GIT_AUTHOR_EMAIL="$GIT_AUTHOR_EMAIL" \
 397                        GIT_AUTHOR_DATE="$GIT_AUTHOR_DATE" \
 398                        $USE_OUTPUT git commit --no-verify \
 399                                $MSG_OPT "$EDIT_OR_FILE" || failed=t
 400                fi
 401                if test $failed = t
 402                then
 403                        cp "$MSG" "$GIT_DIR"/MERGE_MSG
 404                        warn
 405                        warn "Could not apply $sha1... $rest"
 406                        die_with_patch $sha1 ""
 407                fi
 408                ;;
 409        *)
 410                warn "Unknown command: $command $sha1 $rest"
 411                if git rev-parse --verify -q "$sha1" >/dev/null
 412                then
 413                        die_with_patch $sha1 "Please fix this in the file $TODO."
 414                else
 415                        die "Please fix this in the file $TODO."
 416                fi
 417                ;;
 418        esac
 419        test -s "$TODO" && return
 420
 421        comment_for_reflog finish &&
 422        HEADNAME=$(cat "$DOTEST"/head-name) &&
 423        OLDHEAD=$(cat "$DOTEST"/head) &&
 424        SHORTONTO=$(git rev-parse --short $(cat "$DOTEST"/onto)) &&
 425        NEWHEAD=$(git rev-parse HEAD) &&
 426        case $HEADNAME in
 427        refs/*)
 428                message="$GIT_REFLOG_ACTION: $HEADNAME onto $SHORTONTO" &&
 429                git update-ref -m "$message" $HEADNAME $NEWHEAD $OLDHEAD &&
 430                git symbolic-ref HEAD $HEADNAME
 431                ;;
 432        esac && {
 433                test ! -f "$DOTEST"/verbose ||
 434                        git diff-tree --stat $(cat "$DOTEST"/head)..HEAD
 435        } &&
 436        rm -rf "$DOTEST" &&
 437        git gc --auto &&
 438        warn "Successfully rebased and updated $HEADNAME."
 439
 440        exit
 441}
 442
 443do_rest () {
 444        while :
 445        do
 446                do_next
 447        done
 448}
 449
 450# skip picking commits whose parents are unchanged
 451skip_unnecessary_picks () {
 452        fd=3
 453        while read command sha1 rest
 454        do
 455                # fd=3 means we skip the command
 456                case "$fd,$command,$(git rev-parse --verify --quiet $sha1^)" in
 457                3,pick,"$ONTO"*|3,p,"$ONTO"*)
 458                        # pick a commit whose parent is current $ONTO -> skip
 459                        ONTO=$sha1
 460                        ;;
 461                3,#*|3,,*)
 462                        # copy comments
 463                        ;;
 464                *)
 465                        fd=1
 466                        ;;
 467                esac
 468                echo "$command${sha1:+ }$sha1${rest:+ }$rest" >&$fd
 469        done <"$TODO" >"$TODO.new" 3>>"$DONE" &&
 470        mv -f "$TODO".new "$TODO" ||
 471        die "Could not skip unnecessary pick commands"
 472}
 473
 474# check if no other options are set
 475is_standalone () {
 476        test $# -eq 2 -a "$2" = '--' &&
 477        test -z "$ONTO" &&
 478        test -z "$PRESERVE_MERGES" &&
 479        test -z "$STRATEGY" &&
 480        test -z "$VERBOSE"
 481}
 482
 483get_saved_options () {
 484        test -d "$REWRITTEN" && PRESERVE_MERGES=t
 485        test -f "$DOTEST"/strategy && STRATEGY="$(cat "$DOTEST"/strategy)"
 486        test -f "$DOTEST"/verbose && VERBOSE=t
 487        test -f "$DOTEST"/rebase-root && REBASE_ROOT=t
 488}
 489
 490while test $# != 0
 491do
 492        case "$1" in
 493        --no-verify)
 494                OK_TO_SKIP_PRE_REBASE=yes
 495                ;;
 496        --verify)
 497                ;;
 498        --continue)
 499                is_standalone "$@" || usage
 500                get_saved_options
 501                comment_for_reflog continue
 502
 503                test -d "$DOTEST" || die "No interactive rebase running"
 504
 505                # Sanity check
 506                git rev-parse --verify HEAD >/dev/null ||
 507                        die "Cannot read HEAD"
 508                git update-index --ignore-submodules --refresh &&
 509                        git diff-files --quiet --ignore-submodules ||
 510                        die "Working tree is dirty"
 511
 512                # do we have anything to commit?
 513                if git diff-index --cached --quiet --ignore-submodules HEAD --
 514                then
 515                        : Nothing to commit -- skip this
 516                else
 517                        . "$DOTEST"/author-script ||
 518                                die "Cannot find the author identity"
 519                        amend=
 520                        if test -f "$DOTEST"/amend
 521                        then
 522                                amend=$(git rev-parse --verify HEAD)
 523                                test "$amend" = $(cat "$DOTEST"/amend) ||
 524                                die "\
 525You have uncommitted changes in your working tree. Please, commit them
 526first and then run 'git rebase --continue' again."
 527                                git reset --soft HEAD^ ||
 528                                die "Cannot rewind the HEAD"
 529                        fi
 530                        export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE &&
 531                        git commit --no-verify -F "$DOTEST"/message -e || {
 532                                test -n "$amend" && git reset --soft $amend
 533                                die "Could not commit staged changes."
 534                        }
 535                fi
 536
 537                require_clean_work_tree
 538                do_rest
 539                ;;
 540        --abort)
 541                is_standalone "$@" || usage
 542                get_saved_options
 543                comment_for_reflog abort
 544
 545                git rerere clear
 546                test -d "$DOTEST" || die "No interactive rebase running"
 547
 548                HEADNAME=$(cat "$DOTEST"/head-name)
 549                HEAD=$(cat "$DOTEST"/head)
 550                case $HEADNAME in
 551                refs/*)
 552                        git symbolic-ref HEAD $HEADNAME
 553                        ;;
 554                esac &&
 555                output git reset --hard $HEAD &&
 556                rm -rf "$DOTEST"
 557                exit
 558                ;;
 559        --skip)
 560                is_standalone "$@" || usage
 561                get_saved_options
 562                comment_for_reflog skip
 563
 564                git rerere clear
 565                test -d "$DOTEST" || die "No interactive rebase running"
 566
 567                output git reset --hard && do_rest
 568                ;;
 569        -s)
 570                case "$#,$1" in
 571                *,*=*)
 572                        STRATEGY="-s "$(expr "z$1" : 'z-[^=]*=\(.*\)') ;;
 573                1,*)
 574                        usage ;;
 575                *)
 576                        STRATEGY="-s $2"
 577                        shift ;;
 578                esac
 579                ;;
 580        -m)
 581                # we use merge anyway
 582                ;;
 583        -v)
 584                VERBOSE=t
 585                ;;
 586        -p)
 587                PRESERVE_MERGES=t
 588                ;;
 589        -i)
 590                # yeah, we know
 591                ;;
 592        --root)
 593                REBASE_ROOT=t
 594                ;;
 595        --onto)
 596                shift
 597                ONTO=$(git rev-parse --verify "$1") ||
 598                        die "Does not point to a valid commit: $1"
 599                ;;
 600        --)
 601                shift
 602                test -z "$REBASE_ROOT" -a $# -ge 1 -a $# -le 2 ||
 603                test ! -z "$REBASE_ROOT" -a $# -le 1 || usage
 604                test -d "$DOTEST" &&
 605                        die "Interactive rebase already started"
 606
 607                git var GIT_COMMITTER_IDENT >/dev/null ||
 608                        die "You need to set your committer info first"
 609
 610                if test -z "$REBASE_ROOT"
 611                then
 612                        UPSTREAM_ARG="$1"
 613                        UPSTREAM=$(git rev-parse --verify "$1") || die "Invalid base"
 614                        test -z "$ONTO" && ONTO=$UPSTREAM
 615                        shift
 616                else
 617                        UPSTREAM=
 618                        UPSTREAM_ARG=--root
 619                        test -z "$ONTO" &&
 620                                die "You must specify --onto when using --root"
 621                fi
 622                run_pre_rebase_hook "$UPSTREAM_ARG" "$@"
 623
 624                comment_for_reflog start
 625
 626                require_clean_work_tree
 627
 628                if test ! -z "$1"
 629                then
 630                        output git show-ref --verify --quiet "refs/heads/$1" ||
 631                                die "Invalid branchname: $1"
 632                        output git checkout "$1" ||
 633                                die "Could not checkout $1"
 634                fi
 635
 636                HEAD=$(git rev-parse --verify HEAD) || die "No HEAD?"
 637                mkdir "$DOTEST" || die "Could not create temporary $DOTEST"
 638
 639                : > "$DOTEST"/interactive || die "Could not mark as interactive"
 640                git symbolic-ref HEAD > "$DOTEST"/head-name 2> /dev/null ||
 641                        echo "detached HEAD" > "$DOTEST"/head-name
 642
 643                echo $HEAD > "$DOTEST"/head
 644                case "$REBASE_ROOT" in
 645                '')
 646                        rm -f "$DOTEST"/rebase-root ;;
 647                *)
 648                        : >"$DOTEST"/rebase-root ;;
 649                esac
 650                echo $ONTO > "$DOTEST"/onto
 651                test -z "$STRATEGY" || echo "$STRATEGY" > "$DOTEST"/strategy
 652                test t = "$VERBOSE" && : > "$DOTEST"/verbose
 653                if test t = "$PRESERVE_MERGES"
 654                then
 655                        # $REWRITTEN contains files for each commit that is
 656                        # reachable by at least one merge base of $HEAD and
 657                        # $UPSTREAM. They are not necessarily rewritten, but
 658                        # their children might be.
 659                        # This ensures that commits on merged, but otherwise
 660                        # unrelated side branches are left alone. (Think "X"
 661                        # in the man page's example.)
 662                        if test -z "$REBASE_ROOT"
 663                        then
 664                                mkdir "$REWRITTEN" &&
 665                                for c in $(git merge-base --all $HEAD $UPSTREAM)
 666                                do
 667                                        echo $ONTO > "$REWRITTEN"/$c ||
 668                                                die "Could not init rewritten commits"
 669                                done
 670                        else
 671                                mkdir "$REWRITTEN" &&
 672                                echo $ONTO > "$REWRITTEN"/root ||
 673                                        die "Could not init rewritten commits"
 674                        fi
 675                        # No cherry-pick because our first pass is to determine
 676                        # parents to rewrite and skipping dropped commits would
 677                        # prematurely end our probe
 678                        MERGES_OPTION=
 679                        first_after_upstream="$(git rev-list --reverse --first-parent $UPSTREAM..$HEAD | head -n 1)"
 680                else
 681                        MERGES_OPTION="--no-merges --cherry-pick"
 682                fi
 683
 684                SHORTHEAD=$(git rev-parse --short $HEAD)
 685                SHORTONTO=$(git rev-parse --short $ONTO)
 686                if test -z "$REBASE_ROOT"
 687                        # this is now equivalent to ! -z "$UPSTREAM"
 688                then
 689                        SHORTUPSTREAM=$(git rev-parse --short $UPSTREAM)
 690                        REVISIONS=$UPSTREAM...$HEAD
 691                        SHORTREVISIONS=$SHORTUPSTREAM..$SHORTHEAD
 692                else
 693                        REVISIONS=$ONTO...$HEAD
 694                        SHORTREVISIONS=$SHORTHEAD
 695                fi
 696                git rev-list $MERGES_OPTION --pretty=oneline --abbrev-commit \
 697                        --abbrev=7 --reverse --left-right --topo-order \
 698                        $REVISIONS | \
 699                        sed -n "s/^>//p" | while read shortsha1 rest
 700                do
 701                        if test t != "$PRESERVE_MERGES"
 702                        then
 703                                echo "pick $shortsha1 $rest" >> "$TODO"
 704                        else
 705                                sha1=$(git rev-parse $shortsha1)
 706                                if test -z "$REBASE_ROOT"
 707                                then
 708                                        preserve=t
 709                                        for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
 710                                        do
 711                                                if test -f "$REWRITTEN"/$p -a \( $p != $ONTO -o $sha1 = $first_after_upstream \)
 712                                                then
 713                                                        preserve=f
 714                                                fi
 715                                        done
 716                                else
 717                                        preserve=f
 718                                fi
 719                                if test f = "$preserve"
 720                                then
 721                                        touch "$REWRITTEN"/$sha1
 722                                        echo "pick $shortsha1 $rest" >> "$TODO"
 723                                fi
 724                        fi
 725                done
 726
 727                # Watch for commits that been dropped by --cherry-pick
 728                if test t = "$PRESERVE_MERGES"
 729                then
 730                        mkdir "$DROPPED"
 731                        # Save all non-cherry-picked changes
 732                        git rev-list $REVISIONS --left-right --cherry-pick | \
 733                                sed -n "s/^>//p" > "$DOTEST"/not-cherry-picks
 734                        # Now all commits and note which ones are missing in
 735                        # not-cherry-picks and hence being dropped
 736                        git rev-list $REVISIONS |
 737                        while read rev
 738                        do
 739                                if test -f "$REWRITTEN"/$rev -a "$(grep "$rev" "$DOTEST"/not-cherry-picks)" = ""
 740                                then
 741                                        # Use -f2 because if rev-list is telling us this commit is
 742                                        # not worthwhile, we don't want to track its multiple heads,
 743                                        # just the history of its first-parent for others that will
 744                                        # be rebasing on top of it
 745                                        git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$DROPPED"/$rev
 746                                        short=$(git rev-list -1 --abbrev-commit --abbrev=7 $rev)
 747                                        grep -v "^[a-z][a-z]* $short" <"$TODO" > "${TODO}2" ; mv "${TODO}2" "$TODO"
 748                                        rm "$REWRITTEN"/$rev
 749                                fi
 750                        done
 751                fi
 752
 753                test -s "$TODO" || echo noop >> "$TODO"
 754                cat >> "$TODO" << EOF
 755
 756# Rebase $SHORTREVISIONS onto $SHORTONTO
 757#
 758# Commands:
 759#  p, pick = use commit
 760#  e, edit = use commit, but stop for amending
 761#  s, squash = use commit, but meld into previous commit
 762#
 763# If you remove a line here THAT COMMIT WILL BE LOST.
 764# However, if you remove everything, the rebase will be aborted.
 765#
 766EOF
 767
 768                has_action "$TODO" ||
 769                        die_abort "Nothing to do"
 770
 771                cp "$TODO" "$TODO".backup
 772                git_editor "$TODO" ||
 773                        die "Could not execute editor"
 774
 775                has_action "$TODO" ||
 776                        die_abort "Nothing to do"
 777
 778                test -d "$REWRITTEN" || skip_unnecessary_picks
 779
 780                git update-ref ORIG_HEAD $HEAD
 781                output git checkout $ONTO && do_rest
 782                ;;
 783        esac
 784        shift
 785done